#!/usr/local/bin/python
import sys 
#read up to the first blank line, exectuting the commands
while 1:
	aline=sys.stdin.readline()
	if not aline or aline=="\n":
		break
	exec(aline)
#print the standard header for the eps file, with "short cut" def's
print """%!PS-Adobe-2.0 EPSF-2.0
%%Creator: plotter.py
%%DocumentFonts: Geneva
%%BoundingBox: 0 0 """,int(bbx),int(bby),"""
%%EndComments
/fontsize 12 def
/Geneva fontsize selectfont
/cshift fontsize neg def
/vshift fontsize -2 div def
/L {lineto} bind def
/M {moveto} bind def
/S {stroke} bind def
/N {newpath} bind def
/C {setrgbcolor} bind def
/R {rmoveto} bind def
/V {rlineto} bind def
/C {setrgbcolor} bind def   
/Cshow { currentpoint S M
  dup stringwidth pop -2 div cshift R show } def   
/Rshow { dup stringwidth pop neg vshift R -4 0 R show } def    
1 setlinewidth
%%EndProlog""" 
#calculate plot coordinates per user coordinates
xscale=float(bbx-leftmarg-rightmarg)/(xmax-xmin)
yscale=float(bby-botmarg-topmarg)/(ymax-ymin)
#define a bunch of functions that write postscript commands
def ix(x):
	return leftmarg+x*xscale
def jy(y):
	return botmarg+y*yscale
def move(x,y):
	print "N %8.2f %8.2f M"% (ix(x),jy(y))
def line(x1,y1,x2,y2):
	move(x1,y1)
	print "%8.2f %8.2f L S"% (ix(x2),jy(y2))
def draw(alist):
	move(alist.pop(0), alist.pop(0))
	while len(alist) > 1:
		print "%8.2f %8.2f L"% (ix(alist.pop(0)),jy(alist.pop(0)))
	print "S"
def dashdraw(alist):
	print "[3 2] 0 setdash"
	move(alist.pop(0), alist.pop(0))
	while len(alist) > 1:
		print "%8.2f %8.2f L"% (ix(alist.pop(0)),jy(alist.pop(0)))
	print "S"
	print "[] 0 setdash"
def cshow(x,y,text):
	move(x,y)
	print "("+text+") Cshow"
def rshow(x,y,text):
	move(x,y)
	print "("+text+") Rshow"
def xaxis(y,x1,dx,x2):
	print "0.5 setlinewidth\n"
	line(x1,y,x2,y)
	x=x1
	while x < x2*1.00001-dx:
		x=x+dx
		str=xform % x
		move(x,y)
		y2=jy(y)+ticklen
		print "%8.2f %8.2f L S"% (ix(x),y2)
		cshow(x,y,str)
	print "1 setlinewidth\n"
def yaxis(x,y1,dy,y2):
	print "0.5 setlinewidth\n"
	line(x,y1,x,y2)
	y=y1
	while y < y2*1.00001-dy:
		y=y+dy
		str=yform % y
		move(x,y)
		x2=ix(x)+ticklen
		print "%8.2f %8.2f L S"% (x2,jy(y))
		rshow(x,y,str)
	print "1 setlinewidth\n"
def fcircle(x,y,r,red,green,blue):
	print "N %8.2f %8.2f %8.2f 0 360 arc " %  (ix(x),jy(y),r)
	print "closepath gsave %6.3f %6.3f %6.3f C fill grestore" % (red,green,blue) 
def ocircle(x,y,r,red,green,blue):
	print "N %8.2f %8.2f %8.2f 0 360 arc " %  (ix(x),jy(y),r)
	print "closepath gsave %6.3f %6.3f %6.3f C stroke grestore" % (red,green,blue) 
def show(x,y,angle,size,text):
	move(x,y)
	print "gsave /Geneva %d selectfont" % size
	print "%7.2f rotate" % angle 
	print "("+text+") show grestore"
#execute the rest of the lines in the input file
while 1:
	aline=sys.stdin.readline()
	if not aline:
		break
	exec(aline)
