#!/usr/local/bin/python
import sys, re, math, getopt
from string import *
(options,arguements)=getopt.getopt(sys.argv[1:],'t:')
title="could be a title"
for o,a in options:
	if o=="-t":
		title=a
print """bbx=512
bby=512
leftmarg=50
rightmarg=50
botmarg=50
topmarg=50
xmin=0
xinc=.1
xmax=1.
ymin=0.
yinc=.1
ymax=1.
ticklen=10
xform='%5.1f'
yform='%5.1f'

xaxis(ymin,xmin,xinc,xmax)
yaxis(xmin,ymin,yinc,ymax)
line(0,0,1.0,1.0)"""
circs=''
draw=''
while 1:
	aline=sys.stdin.readline()
	if not aline: break
	if re.match('\#',aline):
		a=split(aline)
		for x in a:
			exec(x)
		continue
	[i,y,n,o]=split(aline)
	r=math.sqrt(atof(n))
	y=atof(y)
	o=atof(o)
	s=ob/2.+y/2.
	skill=0
	if (y<ob and o<s) or (y>=ob and o>s): skill =1
#	print "%6.3f" % (atof(y))
	draw+="%6.3f,%6.3f," % (y,o)
	if skill:
		circs+="fcircle(%6.3f,%6.3f,%6.1f,1.,0.,0.)\n" % (y,o,r)
	else:
		circs+="ocircle(%6.3f,%6.3f,%6.1f,1.,0.,0.)\n" % (y,o,r)
print "line(0,%6.3f,1,%6.3f)" % (ob,ob)
print "line(%6.3f,0,%6.3f,1)" % (ob,ob)

print "line(0,%6.3f,1,%6.3f)" % (ob/2,1/2.+ob/2)
draw=draw[:-1]
print 'dashdraw(['+draw+'])'
print circs
print """
show(.03,1.02,0.,24,'"""+title+"""')
show(-.07,.3,90.,14,'observed relative frequency')
show(.3,-.08,0.,14,'forecast probability')"""
