#!/usr/bin/perl
$ob=0.;
$nn=0;
$mse=0;
for $i (0..10){
 $yes{$i}=0;
 $no{$i}=0;
}
while ($line=<>){
  next if $line=~m/^\s*\#/;
  chomp($line);
  $line=~s/^\s+//;
  ($y,$o)=split/\s+/,$line;
  $y=1. if $y>1.;
  $y=0. if $y<0.;
  $bin=int(10.*$y+.5);  
  $mse+=($bin/10.-$o)**2;
  if ($o>.5){
    $yes{$bin}++;
  }
  else{
    $no{$bin}++;
  }
  $ob+=$o;
  $nn++;
}
$ob=$ob/$nn;
$mse=$mse/$nn;
for $i (0..10){
 $n{$i}=$no{$i}+$yes{$i};
 $o{$i}=0.;
 if ($n{$i}>0){
   $o{$i}=1.*$yes{$i}/$n{$i};
 }
#print "H $i $n{$i} $o{$i}\n";
}
$rel=0.;
$res=0.;
$unc=0.;
for $i (0..10){
  $yi=$i/10.;
  $rel+=$n{$i}*($yi-$o{$i})**2;
  $res+=$n{$i}*($o{$i}-$ob)**2;
}
$rel=$rel/$nn;
$res=$res/$nn;
$unc=$ob*(1-$ob);
$brier=$rel-$res+$unc;
$ss=($res-$rel)/$unc;
print "\# mse=$mse  ob=$ob  ss=$ss\n";
print "\# rel=$rel   res=$res   unc=$unc   brier=$brier\n";
sub numerically {$a <=> $b}
#for $key (sort numerically keys %yes){
#  print "$key $yes{$key}\n";
#}
#for $key (sort numerically keys %yes){
#  print "$key $no{$key}\n";
#}
for $key (sort numerically keys %o){
  $yi=$key/10.;
  print "$key $yi $n{$key} $o{$key}\n";
}
